---
- block:
  - name: Update the system
    ansible.builtin.apt:
      update_cache: 'yes'
      cache_valid_time: 3600
      upgrade: full

  rescue:
    - name: Run dpkg --configure -a
      shell: "dpkg --configure -a"

    - name: Remove package lists cache
      shell: "rm -rf /var/lib/apt/lists/*"

    - name: Update package lists
      ansible.builtin.apt:
        update_cache: yes
        autoclean: yes
        cache_valid_time: 0

    - name: Retry updating the system
      ansible.builtin.apt:
        update_cache: 'yes'
        upgrade: full

- name: Configure NTP
  ansible.builtin.package:
    name: ntp
    state: present
  notify: enable and start ntp

- name: Check if snapd is running
  shell: systemctl is-active snapd
  register: snapd_status
  ignore_errors: true

- set_fact:
    snapd_is_active: "{{ snapd_status.stdout == 'active' }}"
  when: snapd_status.rc == 0

- name: Ensure snapd is stopped
  ansible.builtin.systemd:
    name: snapd
    state: stopped
  when: snapd_is_active is defined and snapd_is_active
  ignore_errors: true

- name: Get list of snapd-related packages
  shell: dpkg -l | awk '/^ii  snapd|^ii  gnome-software-plugin-snap|^ii  ubuntu-core-launcher/ {print $2}'
  register: snapd_packages
  failed_when: snapd_packages.rc != 0 and 'no packages found' not in snapd_packages.stderr
  changed_when: false

- name: Remove snapd and related packages
  apt:
    name: "{{ snapd_packages.stdout_lines }}"
    state: absent
    autoremove: yes
    purge: yes
  when: snapd_packages.stdout_lines is defined and snapd_packages.stdout_lines|length > 0

- name: Set timezone to UTC
  ansible.builtin.timezone:
    name: Etc/UTC

- name: Set System Locale
  ansible.builtin.locale_gen:
    name: en_US.UTF-8
